/*
hgetptr.c Version 0.1.0  Hash read database pointer
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* This routine was designed to read */
/* hshhdr->freestk from disk. */
/* However, it is generalized to read */
/* any pointer. */

#include <bthash.h>

long hgetptr(hashfmt *hshhdr, long ofst)
   {
   BOOL   bResult;
   DWORD  msgerr;
   LPVOID lpMsgBuf;
   long loc;
   long ptr;
   DWORD rdlen;
   unsigned char *p;
   hshhdr->reason = 0;
   loc = hseek(hshhdr,ofst);
   if (hshhdr->reason) return(UINT_MAX);
   p = (unsigned char *) &ptr;
   bResult = ReadFile(hshhdr->hndl,
      (unsigned char *) p,
      (DWORD) sizeof(long),
      &rdlen,
      NULL);
   if (!bResult)
      {
      msgerr = GetLastError();
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,           /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,              /* msglen */
         NULL);          /* ins val */
      fprintf(stderr,"hgetptr: %s", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"hgetptr: error reading %s\n"
         "ofst %08x rdlen %d\n",
         hshhdr->dbname, ofst, rdlen);
      fprintf(stderr,"hndl %d loc %08x msgerr %d\n",
         hshhdr->hndl, loc, msgerr);
      hshhdr->reason = SYS_ERR + msgerr;
      return(UINT_MAX);
      } /* read err */
   if (bResult && rdlen == sizeof(long))
      {
      return(ptr);
      } /* good read */
   else
      {
      fprintf(stderr,"hgetptr: error reading %s "
         "ofst %08x rdlen %d\n",
         hshhdr->dbname, ofst, rdlen);
      hshhdr->reason = HASH_ERR + 701;
      return(HASH_ERR + 701);
      } /* read err */
   return(HASH_ERR + 702);
   } /* hgetptr */
